#pragma once

#include "vector.h"
#include "versor.h"
#include "point.h"

const Scalar NO_SOLUTION = INFINITY;

// POD: Plain Old Data
struct Sphere {
	Point center;
	Scalar radius;
};

struct Plane {
	Point p;
	Versor n;
};

struct Ray {
	Point start;
	Vector dir;
};

bool intersection(const Ray& ray, const Plane& plane, Scalar& k, Versor& normal);
bool intersection(const Ray& ray, const Sphere& sphere, Scalar& k, Versor& normal);