#pragma once
#include <vector>  // std::vector
#include <string>
#include "vector.h"

typedef Vector Color;

class Image
{
public:
    const int resX, resY;
    std::vector< Color > data;

    Image(int _resX, int _resY, Color c) : resX(_resX), resY(_resY), data(resX* resY, c) {
        //data.resize(resX*resY);
        //data = std::vector< Color >( resX*resY );
    }

    Image(int _resX, int _resY) : Image(_resX, _resY, Vector(1, 1, 1))
    {}

    Color pixel(int x, int y) const {
        // TODO: range checking
        return data[(resY - y - 1) * resX + x];
    }

    Color& pixel(int x, int y) {
        // TODO: range checking
        return data[(resY - y - 1) * resX + x];
    }


    void exportPPM(std::string filename) const;

};

