#pragma once

#define _USE_MATH_DEFINES
#include <math.h>

typedef float Scalar;

inline bool isZero(Scalar k) {
    return k < 1e-8;
}

inline bool isEqual(Scalar s1, Scalar s2) {
    return isZero((s1 - s2) * (s1 - s2));
}

inline Scalar toRad(Scalar deg) {
    return deg / 180 * M_PI;
}

inline Scalar sign(Scalar x) {
    return (x < 0) ? -1.0f : 1.0f;
}

// custom literals:

// this allows us to write 18.5 to mean "18.5 degrees in randiants"
inline Scalar operator""_deg(long double x) {
    return x * M_PI / 180;
}

// this allows us to write 18 to mean "18 degrees in randiants"
inline Scalar operator""_deg(unsigned long long int x) {
    return x * M_PI / 180;
}

/* note: substitute the non-ascii character  with _deg (and write e.g. 18_deg)
   if your C++ compiler hates the two functions above */
